#GMOuseEditor.py

from code.misc import *
from code.maze import Maze
import pygame
import time
import sys

sys.path = ['.', './code', './levels']
#load file:
filename = "code/test.py"	#change here AND once below to edit a new map.

if len(sys.argv) > 1:
	filename = sys.argv[1]
	if filename[-3:] != ".py":
		filename += ".py"
	if filename[:5] != "code/":
		filename = "code/" + filename
	for name in ["code/maze.py","code/misc.py","code/mouse.py","code/maze.py"]:
		if filename == name:
			print name + " is reserved!"
			exit()
		
try:
	tmpModule = __import__("code." + filename[5:-3])
	maze = getattr(tmpModule,filename[5:-3]).maze
except ImportError:
	try:
		from code.template import maze #import a template if maze doesn't exist
	except ImportError:
		maze = Maze()

#init pygame:
screen = pygame.display.set_mode((w*tileSize, h*tileSize))
darkScreen = pygame.surface.Surface((w*tileSize, h*tileSize), pygame.SRCALPHA)

#init tile images:
for i in range(numTiles):
	tileImages.append(pygame.image.load("img/tile%s.png" % (i + 1,)).convert())
	
#init item images
for i in range(numItems):
	itemImages.append(pygame.image.load("img/item%s.png" % (i + 1,)))
	

#the input function:
def handleInput():
	#shift makes everything rotate backwards.
	mod = 1
	if pygame.key.get_mods() & (pygame.KMOD_LSHIFT | pygame.KMOD_RSHIFT):
		mod = -1
	for event in pygame.event.get():
		if event.type == pygame.QUIT:
			global running
			running = 0
		elif event.type == pygame.MOUSEBUTTONDOWN:
			if event.button == 1:
				#left click is walls
				i = (event.pos[1] + tileSize / 4) * 2 / tileSize
				if i % 2:
					j = (event.pos[0]+ tileSize / 2) / tileSize
				else: 
					j = event.pos[0] / tileSize
				maze.walls[i][j] = (maze.walls[i][j] + mod) % numWalls
			elif event.button == 2:
				#mid click is items
				i = event.pos[1] / tileSize
				j = event.pos[0] / tileSize
				maze.items[i][j] = (maze.items[i][j] + mod) % (numItems + 1)
			elif event.button == 3:
				#right click is tiles
				i = event.pos[1] / tileSize
				j = event.pos[0] / tileSize
				maze.tiles[i][j] = (maze.tiles[i][j] + mod) % (numTiles + 1)
		elif event.type == pygame.KEYDOWN:
			if event.key == pygame.K_s:
				#s is save
				save()
			if event.key == pygame.K_SPACE:
				#space is darkness
				x,y = pygame.mouse.get_pos()
				x /= tileSize
				y /= tileSize
				maze.darkness[y][x] = not maze.darkness[y][x]
				
	
def save():
	file = open(filename, "w")
	fileopened = True
	file.write("from maze import Maze\nmaze = Maze(targetMice=" + str(maze.targetMice) + ")")
	file.write("\nmaze.walls = ")
	file.write(str(maze.walls[:2 * h + 1]))
	file.write("\nmaze.tiles = ")
	file.write(str(maze.tiles[:h]))
	file.write("\nmaze.items = ")
	file.write(str(maze.items[:h]))
	file.write("\nmaze.darkness = ")
	file.write(str(maze.darkness[:h + 1]))
	file.close()
	print "saved!"
	
	backup = open("backups/%s%s.bak"%(filename, time.time()), 'w')	
	backup.write("from maze import Maze\nmaze = Maze(targetMice=" + str(maze.targetMice) + ")")
	backup.write("\nmaze.walls = ")
	backup.write(str(maze.walls[:2 * h + 1]))
	backup.write("\nmaze.tiles = ")
	backup.write(str(maze.tiles[:h]))
	backup.write("\nmaze.items = ")
	backup.write(str(maze.items[:h]))
	backup.write("\nmaze.darkness = ")
	backup.write(str(maze.darkness[:h + 1]))
	backup.close()
	

def run_main():
	global running
	#the main loop:
	running = 1
	
	while running:			
		handleInput()
		maze.drawMaze(screen, darkScreen)
		screen.blit(darkScreen, (0,0))		
		pygame.display.flip()
		
	#save before quitting:
	if not running:
		save()

	
if __name__=="__main__":
	run_main()
	
	
	
	
	
	
	
	
	